/****************************llista.cpp******************************/
#include "llista.h"

int llista::esFi()
{
	//pequenna diferencia con el programa que hace lo mismo en C
	//aqui miramos cuando act apunta a NULL, por tanto, nos
	//hemos pasado del final, el otro lo hace cuando estamos sobre
	//el ultimo numero, pero para el caso gracias a la raiz 
	//cuadrada da el mismo numero

	return (act == NULL);
}

llista::llista()
{
	//funcion constructora, ponemos los punteros a NULL

	pri = NULL;
	act = NULL;
	ult = NULL;
}

void llista::Insereix(int i)
{

	//inserimos al final de la lista

	node *n;
	//definimos el puntero al objeto

	n = new node(i);
	//instanciamos el objecto, pasandole de parametro el numero

	if (n != NULL) {
		//si hemos podido pedir memoria
		n->ModificaSeg(NULL);
		//siempre lo annadimos al final, valdra por tanto
		//NULL el puntero al siguiente


		if (pri == NULL) {
			//si pri==NULL estamos en una lista vacia

			pri = n;
			ult = n;
			act = n;
			//todo tiene que apuntar al nuevo numero

		} else {
			ult->ModificaSeg(n);
			//el que era ultimo antes tendra que apuntar
			//al nuevo ultimo               

			ult = n;
			//y ult tiene que apuntar al nuevo ultimo tambien
		}
	} else {
		cout << "Error de memoria" << endl;
		//nos ha faltado memoria
	}
}

void llista::VesPrincipi()
{
	act = pri;
	//rebobinamos la lista :-)
}

node llista::Consulta()
{
	return (*act);
	//devolvemos el node que apuntamos
}

int llista::ConsultaNum()
{
	node n;
	n = Consulta();

	return (n.ConsultaNum());
	//cojemos el node y devolvemos el numero que contiene
}

void llista::Avanca()
{
	act = act->ConsultaSeg();
	//avanzamos uno
}
