/****************************ppal.cpp************************/
#include "llista.h"
#include "node.h"
#include <iostream.h>

int esPrimer(int n, llista l);

void main()
{
	llista l;
	int n;

	l.Insereix(2);
	//inserimos el numero 2

	cout << "2-";
	//y lo imprimimos por pantalla

	n = 3;
	//empezaremos comprobando el numero 3

	l.VesPrincipi();
	//rebobinamos la lista

	while (n < 2000000) {
		//iremos hasta el numero 2 000 000

		if (esPrimer(n, l) == 1) {
			//si es primero, lo imprimimos y lo inserimos
			cout << n << "-";
			l.Insereix(n);

		}
		n = n + 2;
		//vamos comprobando los numeros impares
	}

}

int esPrimer(int n, llista l)
{
	int ret = 1;
	//pensamos que en principio es primero

	l.VesPrincipi();
	//rebobinamos

	while (ret == 1 && l.esFi() == 0
	       && l.ConsultaNum() * l.ConsultaNum() <= n + 1) {
		//mientras sea primero, no estemos en final de lista y estemos
		//comprobando un numero menor de la raiz cuadrada del numero a 
		//comprobar iremos haciendo

		if (n % l.ConsultaNum() == 0)
			ret = 0;
		//eps! no es primero
		else
			l.Avanca();
		//avanzamos
	}
	return ret;
}
