/****************************llistat.c**************************/
#include "llistat.h"

llistat LLISTAT_Crea()
{
	//funcion que inicializa la estructura LLISTAT
	llistat ll;

	ll.pri = NULL;
	ll.pdi = NULL;
	ll.ult = NULL;

	return ll;
}

llistat LLISTAT_Insereix(llistat ll, int num)
{
	//funcion que annade un numero al final del listado

	node *aux;
	//definimos el puntero a la nueva estructura


	aux = (node *) malloc(sizeof(node));
	//pedimos memoria para la estructura

	if (aux != NULL) {
		aux->num = num;
		//ponemos en el campo num el numero a annadir


		aux->ps = NULL;
		//como annadimos siempre al final, hacemos que no
		//apunte en ningun sitio

		if (ll.pri == NULL) {
			//tenemos de actuar diferente si es el primer numero
			//que annadimos o no lo es

			ll.pri = aux;
			ll.ult = aux;
			ll.pdi = aux;
			//y todos los punteros al unico numero

		} else {
			ll.ult->ps = aux;
			//el que era ultimo, hacemos que apunte al nuevo
			//ultimo

			ll.ult = aux;
			//y el puntero a ultimo que apunte al nuevo 
			//ultimo
		}
	} else {
		printf("Error pidiendo memoria\n");
		exit(0);
	}
	return ll;
	//devolvemos la lista nueva modificada
}

int LLISTAT_Consulta(llistat ll)
{
	return (ll.pdi->num);
	//devolvemos el numero apuntado por pdi
}

int LLISTAT_esFi(llistat ll)
{
	return (ll.pdi->ps == NULL);
	//estamos en el ultimo numero si el puntero a siguiente 
	//no apunta a ningun sitio
}


llistat LLISTAT_VesAlPrincipi(llistat ll)
{
	ll.pdi = ll.pri;
	//hacemos que "punto de interes" sea el principio
}

llistat LLISTAT_Avanca(llistat ll)
{
	ll.pdi = ll.pdi->ps;
	//avanzamos uno, si podemos -si estamos al final ll.pdi
	//apuntara a NULL!! -> un poco incorrecto
	return ll;
}
