/********************************primers.c************************/
#include "llistat.h"

int esPrimer(int c, llistat ll);

int main()
{

	int comprova;
	llistat ll;

	ll = LLISTAT_Crea();
	//iniciamos la lista

	ll = LLISTAT_Insereix(ll, 2);
	//inserimos el numero 2

	ll = LLISTAT_VesAlPrincipi(ll);
	//vamos al principio

	printf("2-");
	//escrivimos el 2 en pantalla

	comprova = 3;
	//empezamos a atacar con el numero 3

	while (comprova < 2000000) {
		//mientras estemos comprobando numeros menores de 2000000
		//seguimos comprobando

		if (esPrimer(comprova, ll)) {
			//si el numero ha sido primero, lo escrivimos
			//en pantalla y lo annadimos en la lista
			printf("%d-", comprova);
			ll = LLISTAT_Insereix(ll, comprova);
		}

		comprova = comprova + 2;
		//avanzamos dos, asi nos saltamos los numeros pares
	}
	return 1;
}

int esPrimer(int c, llistat ll)
{

	//esta funcion nos devuelve 1 si el numero es primero y 0
	//si no lo es

	int ret;
	ret = 1;
	//suponemos que es primero, si conseguimos demostrar que no lo
	//es pues ya devolveremos 0
	ll = LLISTAT_VesAlPrincipi(ll);
	//vamos al principio para hacer las comprobaciones

	while (ret && !LLISTAT_esFi(ll)
	       && LLISTAT_Consulta(ll) * LLISTAT_Consulta(ll) <= c + 1) {
		/*Seguiremos comprobando mientras:
		   -sea primero (si no lo es devolvemos que no loes)
		   -no lleguemos al final del listado (precindible seguramente
		   con la siguiente condicion)
		   -estemos comprobando numeros menores de la raiz cuadrada
		   del numero que estemos atacando
		 */
		if (c % LLISTAT_Consulta(ll) == 0) {
			ret = 0;
			//si la division da exacto, no es primero!
		} else {
			ll = LLISTAT_Avanca(ll);
			//no ha sido primero, avanzamos en la lista
			//(tambien podriamos hacerlo fuera del else)
		}
	}
	return ret;
	//devolvemos la verdad sobre el numero

}
